Index: src/wp-content/themes/twentyeleven/footer.php
===================================================================
--- src/wp-content/themes/twentyeleven/footer.php	(revision 42995)
+++ src/wp-content/themes/twentyeleven/footer.php	(working copy)
@@ -26,6 +26,16 @@
 
 			<div id="site-generator">
 				<?php do_action( 'twentyeleven_credits' ); ?>
+				<?php
+				$privacy_policy_url = get_privacy_policy_url();
+				if ( $privacy_policy_url ) :
+				?>
+					<span class="privacy-policy-page-link">
+						<a href="<?php echo esc_url( $privacy_policy_url ); ?>" aria-label="<?php esc_attr_e( 'Privacy Policy', 'twentyeleven' ); ?>">
+							<?php _e( 'Privacy Policy', 'twentyeleven' ); ?>
+						</a>
+					</span>
+				<?php endif; ?>
 				<a href="<?php echo esc_url( __( 'https://wordpress.org/', 'twentyeleven' ) ); ?>" title="<?php esc_attr_e( 'Semantic Personal Publishing Platform', 'twentyeleven' ); ?>"><?php printf( __( 'Proudly powered by %s', 'twentyeleven' ), 'WordPress' ); ?></a>
 			</div>
 	</footer><!-- #colophon -->
Index: src/wp-content/themes/twentyeleven/style.css
===================================================================
--- src/wp-content/themes/twentyeleven/style.css	(revision 42995)
+++ src/wp-content/themes/twentyeleven/style.css	(working copy)
@@ -2353,7 +2353,11 @@
 	font-weight: bold;
 }
 
+#site-generator .privacy-policy-page-link {
+	display: block;
+}
 
+
 /* =Responsive Structure
 ----------------------------------------------- */
 
Index: src/wp-content/themes/twentyfifteen/footer.php
===================================================================
--- src/wp-content/themes/twentyfifteen/footer.php	(revision 42995)
+++ src/wp-content/themes/twentyfifteen/footer.php	(working copy)
@@ -22,6 +22,16 @@
 				 */
 				do_action( 'twentyfifteen_credits' );
 			?>
+			<?php
+			$privacy_policy_url = get_privacy_policy_url();
+			if ( $privacy_policy_url ) :
+			?>
+				<span class="privacy-policy-page-link">
+					<a href="<?php echo esc_url( $privacy_policy_url ); ?>" aria-label="<?php esc_attr_e( 'Privacy Policy', 'twentyfifteen' ); ?>">
+						<?php _e( 'Privacy Policy', 'twentyfifteen' ); ?>
+					</a>
+				</span>
+			<?php endif; ?>
 			<a href="<?php echo esc_url( __( 'https://wordpress.org/', 'twentyfifteen' ) ); ?>"><?php printf( __( 'Proudly powered by %s', 'twentyfifteen' ), 'WordPress' ); ?></a>
 		</div><!-- .site-info -->
 	</footer><!-- .site-footer -->
Index: src/wp-content/themes/twentyfifteen/style.css
===================================================================
--- src/wp-content/themes/twentyfifteen/style.css	(revision 42995)
+++ src/wp-content/themes/twentyfifteen/style.css	(working copy)
@@ -2434,7 +2434,14 @@
 	color: #333;
 }
 
+.site-info .privacy-policy-page-link:after {
+	content: "\002f";
+	display: inline-block;
+	opacity: 0.7;
+	padding: 0 5px;
+}
 
+
 /**
  * 14.0 Media
  */
Index: src/wp-content/themes/twentyfourteen/footer.php
===================================================================
--- src/wp-content/themes/twentyfourteen/footer.php	(revision 42995)
+++ src/wp-content/themes/twentyfourteen/footer.php	(working copy)
@@ -18,6 +18,16 @@
 
 			<div class="site-info">
 				<?php do_action( 'twentyfourteen_credits' ); ?>
+				<?php
+				$privacy_policy_url = get_privacy_policy_url();
+				if ( $privacy_policy_url ) :
+				?>
+					<span class="privacy-policy-page-link">
+						<a href="<?php echo esc_url( $privacy_policy_url ); ?>" aria-label="<?php esc_attr_e( 'Privacy Policy', 'twentyfourteen' ); ?>">
+							<?php _e( 'Privacy Policy', 'twentyfourteen' ); ?>
+						</a>
+					</span>
+				<?php endif; ?>
 				<a href="<?php echo esc_url( __( 'https://wordpress.org/', 'twentyfourteen' ) ); ?>"><?php printf( __( 'Proudly powered by %s', 'twentyfourteen' ), 'WordPress' ); ?></a>
 			</div><!-- .site-info -->
 		</footer><!-- #colophon -->
Index: src/wp-content/themes/twentyfourteen/style.css
===================================================================
--- src/wp-content/themes/twentyfourteen/style.css	(revision 42995)
+++ src/wp-content/themes/twentyfourteen/style.css	(working copy)
@@ -2916,6 +2916,12 @@
 	color: #41a62a;
 }
 
+.site-info .privacy-policy-page-link:after {
+	content: "\002f";
+	display: inline-block;
+	opacity: 0.7;
+	padding: 0 5px;
+}
 
 /**
  * 9.0 Featured Content
Index: src/wp-content/themes/twentyseventeen/style.css
===================================================================
--- src/wp-content/themes/twentyseventeen/style.css	(revision 42995)
+++ src/wp-content/themes/twentyseventeen/style.css	(working copy)
@@ -2378,6 +2378,13 @@
 	width: 100%;
 }
 
+.site-info .privacy-policy-page-link:after {
+	content: "\002f";
+	display: inline-block;
+	opacity: 0.7;
+	padding: 0 3px;
+}
+
 /*--------------------------------------------------------------
 14.0 Comments
 --------------------------------------------------------------*/
Index: src/wp-content/themes/twentyseventeen/template-parts/footer/site-info.php
===================================================================
--- src/wp-content/themes/twentyseventeen/template-parts/footer/site-info.php	(revision 42995)
+++ src/wp-content/themes/twentyseventeen/template-parts/footer/site-info.php	(working copy)
@@ -10,5 +10,15 @@
 
 ?>
 <div class="site-info">
+	<?php
+	$privacy_policy_url = get_privacy_policy_url();
+	if ( $privacy_policy_url ) :
+	?>
+		<span class="privacy-policy-page-link">
+			<a href="<?php echo esc_url( $privacy_policy_url ); ?>" aria-label="<?php esc_attr_e( 'Privacy Policy', 'twentyseventeen' ); ?>">
+				<?php _e( 'Privacy Policy', 'twentyseventeen' ); ?>
+			</a>
+		</span>
+	<?php endif; ?>
 	<a href="<?php echo esc_url( __( 'https://wordpress.org/', 'twentyseventeen' ) ); ?>"><?php printf( __( 'Proudly powered by %s', 'twentyseventeen' ), 'WordPress' ); ?></a>
 </div><!-- .site-info -->
Index: src/wp-content/themes/twentysixteen/footer.php
===================================================================
--- src/wp-content/themes/twentysixteen/footer.php	(revision 42995)
+++ src/wp-content/themes/twentysixteen/footer.php	(working copy)
@@ -52,6 +52,16 @@
 					do_action( 'twentysixteen_credits' );
 				?>
 				<span class="site-title"><a href="<?php echo esc_url( home_url( '/' ) ); ?>" rel="home"><?php bloginfo( 'name' ); ?></a></span>
+				<?php
+				$privacy_policy_url = get_privacy_policy_url();
+				if ( $privacy_policy_url ) :
+				?>
+					<span class="privacy-policy-page-link">
+						<a href="<?php echo esc_url( $privacy_policy_url ); ?>" aria-label="<?php esc_attr_e( 'Privacy Policy', 'twentysixteen' ); ?>">
+							<?php _e( 'Privacy Policy', 'twentysixteen' ); ?>
+						</a>
+					</span>
+				<?php endif; ?>
 				<a href="<?php echo esc_url( __( 'https://wordpress.org/', 'twentysixteen' ) ); ?>"><?php printf( __( 'Proudly powered by %s', 'twentysixteen' ), 'WordPress' ); ?></a>
 			</div><!-- .site-info -->
 		</footer><!-- .site-footer -->
Index: src/wp-content/themes/twentysixteen/style.css
===================================================================
--- src/wp-content/themes/twentysixteen/style.css	(revision 42995)
+++ src/wp-content/themes/twentysixteen/style.css	(working copy)
@@ -2435,7 +2435,8 @@
 	font-weight: 400;
 }
 
-.site-footer .site-title:after {
+.site-footer .site-title:after,
+.privacy-policy-page-link:after {
 	content: "\002f";
 	display: inline-block;
 	font-family: Montserrat, sans-serif;
Index: src/wp-content/themes/twentyten/footer.php
===================================================================
--- src/wp-content/themes/twentyten/footer.php	(revision 42995)
+++ src/wp-content/themes/twentyten/footer.php	(working copy)
@@ -27,6 +27,16 @@
 				<a href="<?php echo esc_url( home_url( '/' ) ); ?>" title="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>" rel="home">
 					<?php bloginfo( 'name' ); ?>
 				</a>
+				<?php
+				$privacy_policy_url = get_privacy_policy_url();
+				if ( $privacy_policy_url ) :
+				?>
+					<span class="privacy-policy-page-link">
+						<a href="<?php echo esc_url( $privacy_policy_url ); ?>" aria-label="<?php esc_attr_e( 'Privacy Policy', 'twentyten' ); ?>">
+							<?php _e( 'Privacy Policy', 'twentyten' ); ?>
+						</a>
+					</span>
+				<?php endif; ?>
 			</div><!-- #site-info -->
 
 			<div id="site-generator">
@@ -39,6 +49,7 @@
 				do_action( 'twentyten_credits' );
 				?>
 				<a href="<?php echo esc_url( __( 'https://wordpress.org/', 'twentyten' ) ); ?>" title="<?php esc_attr_e( 'Semantic Personal Publishing Platform', 'twentyten' ); ?>"><?php printf( __( 'Proudly powered by %s.', 'twentyten' ), 'WordPress' ); ?></a>
+				
 			</div><!-- #site-generator -->
 
 		</div><!-- #colophon -->
Index: src/wp-content/themes/twentyten/style.css
===================================================================
--- src/wp-content/themes/twentyten/style.css	(revision 42995)
+++ src/wp-content/themes/twentyten/style.css	(working copy)
@@ -1299,6 +1299,12 @@
 	color: #000;
 	text-decoration: none;
 }
+#site-info .privacy-policy-page-link:before {
+	content: "\002f";
+	display: inline-block;
+	opacity: 0.7;
+	padding: 0 7px;
+}
 #site-generator {
 	font-style: italic;
 	position: relative;
Index: src/wp-content/themes/twentythirteen/footer.php
===================================================================
--- src/wp-content/themes/twentythirteen/footer.php	(revision 42995)
+++ src/wp-content/themes/twentythirteen/footer.php	(working copy)
@@ -16,6 +16,16 @@
 
 			<div class="site-info">
 				<?php do_action( 'twentythirteen_credits' ); ?>
+				<?php
+				$privacy_policy_url = get_privacy_policy_url();
+				if ( $privacy_policy_url ) :
+				?>
+					<span class="privacy-policy-page-link">
+						<a href="<?php echo esc_url( $privacy_policy_url ); ?>" aria-label="<?php esc_attr_e( 'Privacy Policy', 'twentythirteen' ); ?>">
+							<?php _e( 'Privacy Policy', 'twentythirteen' ); ?>
+						</a>
+					</span>
+				<?php endif; ?>
 				<a href="<?php echo esc_url( __( 'https://wordpress.org/', 'twentythirteen' ) ); ?>"><?php printf( __( 'Proudly powered by %s', 'twentythirteen' ), 'WordPress' ); ?></a>
 			</div><!-- .site-info -->
 		</footer><!-- #colophon -->
Index: src/wp-content/themes/twentythirteen/style.css
===================================================================
--- src/wp-content/themes/twentythirteen/style.css	(revision 42995)
+++ src/wp-content/themes/twentythirteen/style.css	(working copy)
@@ -2705,7 +2705,11 @@
 	margin: -10px auto 0;
 }
 
+.site-info .privacy-policy-page-link {
+	display: block;
+}
 
+
 /**
  * 8.0 Media Queries
  * ----------------------------------------------------------------------------
Index: src/wp-content/themes/twentytwelve/footer.php
===================================================================
--- src/wp-content/themes/twentytwelve/footer.php	(revision 42995)
+++ src/wp-content/themes/twentytwelve/footer.php	(working copy)
@@ -13,6 +13,16 @@
 	<footer id="colophon" role="contentinfo">
 		<div class="site-info">
 			<?php do_action( 'twentytwelve_credits' ); ?>
+			<?php
+			$privacy_policy_url = get_privacy_policy_url();
+			if ( $privacy_policy_url ) :
+			?>
+				<span class="privacy-policy-page-link">
+					<a href="<?php echo esc_url( $privacy_policy_url ); ?>" aria-label="<?php esc_attr_e( 'Privacy Policy', 'twentytwelve' ); ?>">
+						<?php _e( 'Privacy Policy', 'twentytwelve' ); ?>
+					</a>
+				</span>
+			<?php endif; ?>
 			<a href="<?php echo esc_url( __( 'https://wordpress.org/', 'twentytwelve' ) ); ?>" title="<?php esc_attr_e( 'Semantic Personal Publishing Platform', 'twentytwelve' ); ?>"><?php printf( __( 'Proudly powered by %s', 'twentytwelve' ), 'WordPress' ); ?></a>
 		</div><!-- .site-info -->
 	</footer><!-- #colophon -->
Index: src/wp-content/themes/twentytwelve/style.css
===================================================================
--- src/wp-content/themes/twentytwelve/style.css	(revision 42995)
+++ src/wp-content/themes/twentytwelve/style.css	(working copy)
@@ -694,6 +694,12 @@
 footer[role="contentinfo"] a:hover {
 	color: #21759b;
 }
+.site-info .privacy-policy-page-link:after {
+	content: "\002f";
+	display: inline-block;
+	opacity: 0.7;
+	padding: 0 5px;
+}
 
 
 /* =Main content and comment content